// How much time the stat update should be delayed
var BT_UPDATE_DELAY_MS = 3000;
var BT_SECONDS_INTERVAL = 15 * 60; // 15 minutes
//SHIFT - for interval selection
var BT_INTERVAL_KEY_CODE = 16;
//CTRL - for multijob selections
var BT_MULTI_KEY_CODE = 17;
// Finding a checkbox which timestamp its related to
var bt_job_timestamp_regexp = new RegExp(/^bt_job_(\d*)_timestamp_(\d*)$/g);
// Check if keys are down
var interval_key_is_active = false;
var multi_key_is_active = false;
// setTimeout var
var bt_update_delay;
// true if changes occured on the form
var bt_update_need_save_flag = false;
// nodes
var bt_job_array = [];
// true if charts isnt refreshed
var bt_first_reload = true;
// during interval selection the first checkbox
var bt_multiselect_fst_item = false;


if (Drupal.jsEnabled) {
  $(function() {
    $("input:checkbox[zebra='odd']").parent().parent().css('background', '#D0EDF7');
    $('.title_hour').parent().css('width', (100 / $('.title_hour').length) + '%');
    
    // Bind events to checkbox events
    $('input:checkbox').click(bt_checkbox_toggle);
    $('input:checkbox').mouseover(function(){bt_highlight_titles(this, true);});
    $('input:checkbox').mouseout(function(){bt_highlight_titles(this, false);});
    
    if (bt_piechart_enable || bt_barchart_enable) {
      $('#bt_chart_title').show();
    }

    // Scroll bubbletimer to 8 o'clock
    // Sorry for this ugly hardcode
    $('div#bt_scroller').scrollLeft(544);

    $(window).keydown(function(event){
      switch (event.keyCode) {
        case BT_INTERVAL_KEY_CODE:
          interval_key_is_active = true;
          multi_key_is_active = false;
          break;
        case BT_MULTI_KEY_CODE:
          multi_key_is_active = true;
          interval_key_is_active = false;
          break;
        default:
          interval_key_is_active = false;
          multi_key_is_active = false;
          break;
      }
    });
    $(window).keyup(function(event){
      interval_key_is_active = false;
      multi_key_is_active = false;
      bt_multiselect_fst_item = null;
    });

    $.each($('a.job_node'), function() {
      bt_job_array.push($(this).attr('nid'));
    });

    // Update stats
    bt_update_stats();
  });
}
	

/**
 * Handle a checkbox click event (or simulated click ~ mouseover)
 * If CTRL is down, multiple selection allowed, otherwise doesn't
 * @return
 */
function bt_checkbox_toggle() {
  // Setup a notifier to make us save the changes
  if (!bt_update_need_save_flag) {
    bt_update_need_save_flag = true;
    $('#bt_activity_wrapper').after('<div id="bt_notify_to_save" class="messages warning">Your timesheet changed. Don\'t forget to save it!</div>');
    $('div#bt_notify_to_save').show('slow');
  }
  
  // Multi task selection
  if (multi_key_is_active) {
    return;
  }  
  
  // Interval selection
  if (interval_key_is_active) {
    if (!bt_multiselect_fst_item) {
      // Start a new multiselection
      bt_multiselect_fst_item = this;
    } else {
      // Finish a multiselection
      var nid = $(this).attr('nid');
      if ($(bt_multiselect_fst_item).attr('nid') == nid) {
        var timestamp_from = Math.min($(this).attr('timestamp'), $(bt_multiselect_fst_item).attr('timestamp'));
        var timestamp_to   = Math.max($(this).attr('timestamp'), $(bt_multiselect_fst_item).attr('timestamp'));
        for (var t = timestamp_from; t <= timestamp_to; t += BT_SECONDS_INTERVAL) {
          $("input:checkbox[timestamp='" + t + "'][nid='" + nid + "']").attr('checked', 'checked');
        }
        bt_update_stats();
      } else {
        alert('Interval selection only applicable in the same activity line.');
      }
      bt_multiselect_fst_item = false;
      //interval_key_is_active = false;
    }
    return;
  }
  
  if (!$(this).attr('checked')) {
    $(this).attr('checked', null);
    bt_update_stats();
    return;
  }
  
  var timestamp = $(this).attr('timestamp');
  $("input:checkbox[timestamp='" + timestamp + "']").attr('checked', null);
  $(this).attr('checked', 'true');

  bt_update_stats();
}


/**
 * Update statistics
 * It has a 3 seconds delay to prevent being blocked by google-chart
 * 	- time sums
 * 	- google chart
 * @return
 */
function bt_update_stats() {
  // Update stats
  bt_throbber_on();
  clearTimeout(bt_update_delay);
  if (bt_first_reload) {
    _bt_update_stats_batch();
    bt_first_reload = false;
  } else {
    bt_update_delay = setTimeout("_bt_update_stats_batch();", BT_UPDATE_DELAY_MS);
  }
}


/**
 * Call updaters
 * @return
 */
function _bt_update_stats_batch() {
  bt_update_activity_percent();
  bt_update_chart();
}


/**
 * Update node titles in the timesheet, how much percent of usage those has
 */
function bt_update_activity_percent() {
  var checkbox_array = $('input:checkbox:checked');
  var job_checked_array = [];
  $.each(checkbox_array, function() {
    job = $(this).attr('name').replace(bt_job_timestamp_regexp, "$1");
    if (job) {
      if (!job_checked_array[job]) {
        job_checked_array[job] = 0;
      }
      job_checked_array[job]++;
    }
  });
  $.each(bt_job_array, function() {
    hours = job_checked_array[this] * 0.25;
    $('span#bt_node_percent_' + this).html((hours || 0).toString());
  });

  $('span.bt_sum_hour').html(((checkbox_array.length * 0.25) || 0).toString());
}


/**
 * Update google chart
 * @return
 */
function bt_update_chart() {
  if (!bt_piechart_enable && !bt_barchart_enable) {
    bt_throbber_off();
    return;
  }
  
  var url_pie = 'http://chart.apis.google.com/chart?chs=400x100&cht=p3&chco=0072b9,E8B305,E8003A,6DE809&';
  var url_bar = 'http://chart.apis.google.com/chart?cht=bvg&chco=FF2A2A,FFBE33,AAFF33,36FFE1,365BFF,AE35FF,FF36A1,FF8383,FFD884,BAFF81,84FFD0,88B4FF,BB84FF,FF88DD&chds=0,8&chxt=y&chxr=0,0,8,2&';
  var percent = [];
  var total = [];
  var title = [];
  var times = [];
  var sum = 0;

  $.each($('table#bt_title_wrapper tbody tr'), function() {
    time = parseFloat($('span', this).html());
    if (time > 0) {
      title.push(encodeURIComponent($('a', this).html()));
      times.push(time);
      sum += time;
    }
  });

  if (times.length == 0) {
    bt_throbber_off();
    $('div#bt_chart_placeholder').html('');
    return;
  }

  $.each(times, function() {
    percent.push(100 * (this / sum));
    total.push(this);
  });
	
  percent_url_pie = percent.join(',');
  total_url_bar   = total.join('|');
  title_url       = title.join('|');
	
  url_pie = url_pie + 'chd=t:' + percent_url_pie + '&chl=' + title_url;
  url_bar = url_bar + 'chs=540x' + (title.length * 18 > 100 ? title.length * 18 : 100) + '&chd=t:' + total_url_bar + '&chdl=' + title_url;
  pie_img = bt_piechart_enable ? '<img src="'+ url_pie + '" />' : '';
  bar_img = bt_barchart_enable ? '<img src="'+ url_bar + '" />' : '';
  $('div#bt_chart_placeholder').html(pie_img + bar_img);
  $('div#bt_chart_placeholder img').load(function() {bt_throbber_off();});
}


/**
 * Higlight the related titles for checboxes you are onmouseover
 * @param object oItem
 * @param boolean is_highlight
 * @return
 */
function bt_highlight_titles(oItem, is_highlight) {
  var hour = $(oItem).attr('hour');
  var nid  = $(oItem).attr('nid');
  if (is_highlight) {
    $("a[nid='" + nid + "']").parent().addClass('bt_title_highlight');
    $("div[hour='" + hour + "']").addClass('bt_title_highlight');
  } else {
    $("a[nid='" + nid + "']").parent().removeClass('bt_title_highlight');
    $("div[hour='" + hour + "']").removeClass('bt_title_highlight');
  }
}


/**
 * Loader icon on
 * @return
 */
function bt_throbber_on() {
  $('span.bt_chart_updater').addClass('occupied');
}


/**
 * Loader icon off
 * @return
 */
function bt_throbber_off() {
  $('span.bt_chart_updater').removeClass('occupied');
}
